<?php
	class Pages extends CI_Controller{

		public function __construct() { 
		      parent::__construct(); 
		      $this->load->library("flash");
		      $this->load->library("flash");
			$this->load->model('vendor_model');
			$this->load->model('fav_model');
		   }

		public function index($page = 'home'){
			if(!file_exists(APPPATH.'views/pages/'.$page.'.php')){
				show_404();
			}
			// var_dump($vendors);exit;


			$data['title'] = ucfirst($page);

			$this->load->view('templates/header', $data);
			$this->load->view('pages/'.$page, $data);
			$this->load->view('templates/footer');
		}

		public function makeFav() {
			if($this->session->userdata('logged_in') == NULL){
				$res = array(
					'status' => 'error',
					'code' => 1
				);
					echo json_encode($res);
					exit;
			    }

				$id = $_POST['id'];
				$user_id = $this->session->userdata('user_id');
			    $vendor = $this->vendor_model->get_vendor_by_id($id);
			    $vendor_id = $vendor[0]['vendor_account_id'];

			    $create_fav = $this->fav_model->create_fav($user_id, $vendor_id);
			    if($create_fav) {
			    	$res = array(
			    		'status' => 'success',
			    		'code' => 2
			    	);
				echo json_encode($res);
					exit;
			    }
		}

		public function register($page = 'register'){
			if(!file_exists(APPPATH.'views/pages/'.$page.'.php')){
				show_404();
			}

			if(isset($_POST) && !empty($_POST)) {
				if(!isset($_POST['fullname']) || !isset($_POST['email']) || !isset($_POST['phoneNumber']) || !isset($_POST['password'])) {
					$res = array(
						'status' => 'error',
						'code' => 0
					);
					echo json_encode($res);exit;
				}

				$fullname = $_POST['fullname'];
				$email = $_POST['email'];
				$phoneNumber = $_POST['phoneNumber'];
				$password = $_POST['password'];

				if($fullname == "" || $email == "" || $phoneNumber == "" || $password == "") {
					$res = array(
						'status' => 'error',
						'code' => 1
					);
					echo json_encode($res);exit;
				}

				$email_exist = $this->user_model->check_email_exists($email);
				if(!$email_exist) {
					$res = array(
						'status' => 'error',
						'code' => 2
					);
					echo json_encode($res);exit;
				}

				$register = $this->user_model->register($fullname, $email, $phoneNumber, $password);
				if($register) {
					// Send email to user
					$this->load->library('email');

					$this->email->from('support@thenewbroker.com', 'Admin');
					$this->email->to($email);
					$this->email->cc('admin@thenewbroker.com');
					$this->email->bcc('postman@thenewbroker.com');

					$this->email->subject('Verification Link');
					$this->email->message('Hello your account has been created');

					$this->email->send();

					$res = array(
						'status' => 'success',
						'code' => 0
					);
					echo json_encode($res);exit;
				}


			}

			$data['title'] = ucfirst($page);

			$this->load->view('templates/header', $data);
			$this->load->view('pages/'.$page, $data);
			$this->load->view('templates/footer');
		}

		public function login($page = 'login'){
			if(!file_exists(APPPATH.'views/pages/'.$page.'.php')){
				show_404();
			}

			if(isset($_POST) && !empty($_POST)) {
				if(!isset($_POST['email']) || !isset($_POST['password'])) {
					$res = array(
						'status' => 'error',
						'code' => 0
					);
					echo json_encode($res);exit;
				}

				$email = $_POST['email'];
				$password = $_POST['password'];

				if($email == "" || $password == "") {
					$res = array(
						'status' => 'error',
						'code' => 1
					);
					echo json_encode($res);exit;
				}

				$login = $this->user_model->login($email, $password);
				if($login) {	
					
					$res = array(
						'status' => 'success',
						'code' => 0
					);
					echo json_encode($res);exit;
				}


			}

			$data['title'] = ucfirst($page);

			$this->load->view('templates/header', $data);
			$this->load->view('pages/'.$page, $data);
			$this->load->view('templates/footer');
		}

		public function blog($page = 'blog'){
			if(!file_exists(APPPATH.'views/pages/'.$page.'.php')){
				show_404();
			}

			$data['title'] = ucfirst($page);

			$this->load->view('templates/header', $data);
			$this->load->view('pages/'.$page, $data);
			$this->load->view('templates/footer');
		}
	}